<script lang="ts" setup>
import { nextTick, onMounted, ref, computed } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Promotion } from '@/types/Promotion'
import http from '@/services/http'
import promotionService from '@/services/promotion'
import { usePromotionStore } from '@/stores/promotion'
import { useLoadingStore } from '@/stores/loading'
const promotionStore = usePromotionStore() //
const loadingStore = useLoadingStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Start Date',
    key: 'startDate',
    value: 'startDate'
  },
  {
    title: 'End Date',
    key: 'endDate',
    value: 'endDate'
  },
  {
    title: 'Details',
    key: 'details',
    value: 'details'
  },
  {
    title: 'Discount',
    key: 'discount',
    value: 'discount'
  },
  {
    title: 'PointUse',
    key: 'pointUse',
    value: 'pointUse'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const promotionCount = computed(() => promotionStore.promotions.length)
const initilPromotion: Promotion = {
  id: -1,
  name: '',
  startDate: new Date(),
  endDate: new Date(),
  details: '',
  pointUse: 0,
  discount: 0,
  status: 'Active'
}
const editedPromotion = ref<Promotion>(JSON.parse(JSON.stringify(initilPromotion)))
let editedIndex = -1
let lastId = 4
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedPromotion.value = Object.assign({}, initilPromotion)
  })
}
async function getPromotion() {
  loadingStore.doLoad()
  const res = await promotionService.getAllPromotion()
  promotionStore.promotions = res.data
  loadingStore.finish()
}
async function deleteItemConfirm() {
  // Delete item from list
  await promotionStore.deletePromotion(editedPromotion.value)
  closeDelete()
}
function editItem(item: Promotion) {
  editedPromotion.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Promotion) {
  editedPromotion.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedPromotion.value = Object.assign({}, initilPromotion)
    editedIndex = -1
    console.log(promotionCount.value)
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  closeDialog()
  await promotionStore.savePromotion(editedPromotion.value)
}
onMounted(() => {
  getPromotion()
})
</script>
<template>
  <div>
    <v-data-table :headers="headers" :items="promotionStore.promotions">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Promotions</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Promotion </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Promotion List</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedPromotion.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedPromotion.startDate"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Start Date"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedPromotion.endDate"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="End Date"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedPromotion.details"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Details"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedPromotion.discount"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Discount"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedPromotion.pointUse"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="pointUse"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-combobox
                          label="Status"
                          :items="['Active', 'Inactive']"
                          v-model="editedPromotion.status"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="promotionStore.getPromotion"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
